import sdl
from numeric import *


class Painter(object):
    def __init__(self, size):
        self.resize(size)

    def blit(self, surface, flip=False):
        self.ubuffer[:,:] = self.buffer.astype(uint8)
        sdl.surfarray.blit_array(surface, self.ubuffer)
        if flip: sdl.display.flip()

    def resize(self, size):
        w, h = size
        self.size = size
        self.clear()
        self.ubuffer = num.zeros((w, h, 3), num.UInt8)

    def clear(self, rgb=(255, 255, 255)):
        w, h = self.size
        self.buffer = zeros((w, h, 3), float) + rgb
        self.zbuffer = zeros(self.size, float) + 10.0**6
        self.zmax = -10.0**7
        self.nbuffer = zeros((w, h, 3), float)

    def paint(self, x, y, color):
        self.buffer[x,y] = color

    def dpaint(self, x, y, z):
        p = x, y
        if z < self.zbuffer[p]:
            self.zmax = max(self.zmax, z)
            self.zbuffer[p] = z

    def npaint(self, x, y, z, n):
        p = x, y
        if z < self.zbuffer[p]:
            self.zbuffer[p] = z
            self.nbuffer[p] = n

    def zpaint(self, x, y, z, color):
        p = x, y
        if z < self.zbuffer[p]:
            self.zbuffer[p] = z
            self.buffer[p] = color
